/*
 * Variable type definitions useful for GBA development
 * By Erik Gillespie
 */

#ifndef GBA_TYPES_H
#define GBA_TYPES_H

/* True-to-form data types */

typedef unsigned char    u8;
typedef unsigned short   u16;
typedef unsigned long    u32;

typedef signed char      s8;
typedef signed short     s16;
typedef signed long      s32;

typedef unsigned char    byte;
typedef unsigned short   hword;
typedef unsigned long    word;

/* Macros that return virtual "types" */

/* Color macros */
#define RGB16(r,g,b)     ((hword)(r | (g<<5) | (b<<10)))
#define BGR16(b,g,r)     RGB16(r,g,b)
#define RGB(r,g,b)       RGB16(r,g,b)
#define BGR(b,g,r)       RGB16(r,g,b)

#endif
