/*
 * Screen mode flags and function macros
 * Originally by Dovoto
 * Modifications by Erik Gillespie
 */

#ifndef GBA_VIDEO_H
#define GBA_VIDEO_H

#include "gbaregs.h"

#define MODE0           0x00
#define MODE1           0x01
#define MODE2           0x02
#define MODE3           0x03
#define MODE4           0x04
#define MODE5           0x05

#define BACKBUFFER      0x10
#define H_BLANK_OAM     0x20

#define OBJ_MAP_2D      0x00
#define OBJ_MAP_1D      0x40

#define FORCE_BLANK     0x80

#define BG0_ENABLE      0x0100
#define BG1_ENABLE      0x0200 
#define BG2_ENABLE      0x0400
#define BG3_ENABLE      0x0800
#define OBJ_ENABLE      0x1000 

#define WIN1_ENABLE     0x2000 
#define WIN2_ENABLE     0x4000
#define WINOBJ_ENABLE   0x8000

#define SetVideoMode(mode) REG_DISPCNT = (mode)

#endif
