#include "gba.h" // types u8,u16,...
// v1.0 written 2-9-03 Stephen Stair
// modified 3-4-03, adding header files for gfx and pals
// basic routineheader file for card party gba project

// this may be added to but likely won't change.
// Devkit Advance passes all paramaters in 32bit
// format - so it doesn't make sense to pass params
// less than 32bit.

#ifdef __cplusplus
extern "C" {
#endif

// Graphics routines:
void WaitVblank();	// wait for vblank to occur

// bitmap mode:
int GetTextLength(u32 font, char * fs);
void TextOut(s32 x, s32 y, u32 width, u32 height, u32 font, char * fs,u32 color);
void DrawLine(s32 x1, s32 y1, s32 x2, s32 y2, u32 color);

typedef void (*SetPixel_func)(s32,s32,u32);
typedef u32 (*GetPixel_func)(s32,s32);

extern SetPixel_func SetPixel;
extern GetPixel_func GetPixel;


// input:
void UpdateKeys(); // call once a vblank
u32 GetKeys(void);

#define KEY_L 0x0200
#define KEY_R 0x0100
#define KEY_DN 0x080
#define KEY_UP 0x040
#define KEY_LF 0x020
#define KEY_RT 0x010
#define KEY_STR 0x08
#define KEY_SEL 0x04
#define KEY_B 0x0002
#define KEY_A 0x0001
#define KEY_START KEY_STR
#define KEY_SELECT KEY_SEL
#define KEY_DOWN KEY_DN
#define KEY_LEFT KEY_LF
#define KEY_RIGHT KEY_RT
#define KeyDown(key) ((GetKeys()>>16)&(key))
#define KeyPressed(key) ((GetKeys())&(key))




// other routines
void SoftReset();
void SleepKey(u32 KeyMask); // GBA hibernates until key in keymask is pressed.
u32 gbarand();
u32 gbasrand(u32 seed);





#ifdef __cplusplus
}
#endif


